/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.2 by edhill, Mon Sep 1 16:50:27 2003 UTC revision 1.42 by jmc, Thu Jul 8 15:47:19 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  #  $Header$  #  $Header$
4    #  $Name$
5  #  #
6    
7  usage()  usage()
# Line 10  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-optfile=|-of=)STRING   list of genmake2 \"optfiles\""      echo "  (-mpi)                   use MPI input files"
15      echo "  (-a|-addr)STRING         list of email recipients"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
16      echo "  (-t|-tdir)STRING         list of \"test\" dirs"      echo "                             (DEF=\"-ieee\")"
17        echo "  (-optfile=|-of=)STRING   list of optfiles to use"
18        echo "  (-a|-addr) STRING        list of email recipients"
19        echo "                             (DEF=\"edhill@mitgcm.org\")"
20        echo "  (-t|-tdir) STRING        list of test dirs to use"
21        echo "                             (DEF=\"\" which builds all)"
22        echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
23        echo "                             Bourne-compatible \"sh\" shell"
24        echo "                             (DEF=\"\" for \"bash\")"
25        echo "  (-adm|-ad)               perform an adjoint run"
26        echo "  (-command) STRING        command to run"
27        echo "                             (DEF=\"make output.txt\")"
28        echo "  (-m|-make) STRING        command to use for \"make\""
29        echo "                             (DEF=\"make\")"
30        echo "  (-clean)                 *ONLY* run \"make CLEAN\""
31        echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
32        echo "  (-nogenmake|-ng)         skip the genmake stage"
33        echo "  (-noclean|-nc)           skip the \"make clean\" stage"
34        echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
35        echo "  (-deldir|-dd)            on success, delete the output directory"
36        echo
37        echo "and where STRING follows a whitespace-delimited format"
38        echo "such as:"
39        echo "  -t 'exp0 exp2 exp3' "
40        echo "  -addr='abc@123.com testing@home.org'"
41      echo      echo
42      exit 1      exit 1
43  }  }
# Line 20  usage() Line 45  usage()
45  #  build the mpack utility  #  build the mpack utility
46  build_mpack()  build_mpack()
47  {  {
48      echo -n "building the mpack utility...  "      printf "building the mpack utility...  "
49      if test ! -x "$MPACKDIR/mpack" ; then      if test ! -x "$MPACKDIR/mpack" ; then
50          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
51                echo
52              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
53              echo "  are you sure this program is being run in the correct "              echo "  are you sure this program is being run in the correct "
54              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"
55              exit 1              echo
56                HAVE_MPACK=f
57            fi
58            printf "building mpack...  "
59            if test "x$CC" = x ; then
60                export CC=cc
61          fi          fi
62          echo -n "building mpack...  "          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
         ( cd $MPACKDIR && ./configure && make ) > build_mpack.out 2>&1  
63          RETVAL=$?          RETVAL=$?
64          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
65              echo              echo
66              echo "Error building the mpack tools at: $MPACK_DIR"              echo "Error building the mpack tools at: $MPACK_DIR"
67              exit 1              echo
68                HAVE_MPACK=f
69            else
70                rm -f tr_build_mpack.out
71                HAVE_MPACK=t
72          fi          fi
73        else
74            HAVE_MPACK=t
75      fi      fi
76      echo "OK"      echo "OK"
77  }  }
78    
 compare_lines()  
 {  
     # use codelet to compare lines  
     if [ $verbose -gt 1 ]; then  
         cat tmp3.txt 1>&2  
     fi  
     return `./a.out < tmp3.txt`  
 }  
   
79  testoutput_for_prop()  testoutput_for_prop()
80  {  {
81      # testoutput_for_prop dir s1 label subdir      # testoutput_for_prop dir s1 label subdir extension
82      #      #
83      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt
84      #  using search strings s1 and text label      #  using search strings s1 and text label
# Line 60  testoutput_for_prop() Line 87  testoutput_for_prop()
87          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2
88      fi      fi
89      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/output.txt ]; then
90          grep "$2" $1/$4/output.txt | sed 's/.*=//' | nl > tmp1.txt          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt
91          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncnt=`wc -l tmp1.txt | awk '{print $1}' `
92          if [ $lncnt -lt 3 ]; then          if [ $lncnt -lt 3 ]; then
93              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
# Line 73  testoutput_for_prop() Line 100  testoutput_for_prop()
100          return 99          return 99
101      fi      fi
102      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
103          echo testoutput_for_prop: grep "$2" $1/results/output.txt 1>&2          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2
104      fi      fi
105      grep "$2" $1/results/output.txt | sed 's/.*=//' | nl > tmp2.txt      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt
106      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncnt=`wc -l tmp2.txt | awk '{print $1}' `
107      if [ $lncnt -lt 3 ]; then      if [ $lncnt -lt 3 ]; then
108          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
# Line 90  testoutput_for_prop() Line 117  testoutput_for_prop()
117      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
118          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_for_prop: compare_lines 1>&2
119      fi      fi
120      compare_lines      if [ $verbose -gt 1 ]; then
121      digits_of_similarity=$?          cat tmp3.txt 1>&2
122        fi
123        echo "-1" >> tmp3.txt
124        # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
125        cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
126        digits_of_similarity=`./tmp_cmpnum < tmp4.txt`
127      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
128          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
129              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2
# Line 102  testoutput_for_prop() Line 134  testoutput_for_prop()
134              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2
135          fi          fi
136      fi      fi
137      rm tmp1.txt tmp2.txt tmp3.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
138            
139      return $digits_of_similarity      return $digits_of_similarity
140  }  }
# Line 122  dashnum() Line 154  dashnum()
154      done      done
155  }  }
156    
157    testoutput_ad()
158    {
159        grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $5}' > t05.txt
160        grep $3 $1/$2/output.txt_adm | awk '{print NR " " $5}' > t15.txt
161        grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $6}' > t06.txt
162        grep $3 $1/$2/output.txt_adm | awk '{print NR " " $6}' > t16.txt
163        join t05.txt t15.txt > t5.txt
164        join t06.txt t16.txt > t6.txt
165        echo "-1" >> t5.txt
166        echo "-1" >> t6.txt
167        digits_5=`./tmp_cmpnum < t5.txt`
168        digits_6=`./tmp_cmpnum < t6.txt`
169        dashnum $digits_5 $digits_6
170        rm -f t[01][56].txt t[56].txt
171    }
172    
173  testoutput()  testoutput()
174  {  {
175      # testoutput diretory subdir      # testoutput directory subdir extension
176      #      #
177      #  test output in "directory"      #  test output in "directory"
178        if test "x$ADM" = x ; then
179      if [ $debug -gt 0 ]; then          if [ $debug -gt 0 ]; then
180          echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2              echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2
181      fi          fi
182      testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2; cg2dres=$?          testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?
183      if [ $debug -gt 0 ]; then          if [ $debug -gt 0 ]; then
184          echo testoutput: cg2dres=$cg2dres 1>&2              echo testoutput: cg2dres=$cg2dres 1>&2
185            fi
186            testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?
187            testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?
188            testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?
189            testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?
190            testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?
191            testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?
192            testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?
193            testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?
194            testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?
195            testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?
196            testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?
197            testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?
198            testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?
199            testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?
200            testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?
201            testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?
202            dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \
203                $umin $umax $umean $usd $vmin $vmax $vmean $vsd
204        else
205            testoutput_ad $1 $2 "precision_grdchk_result"
206      fi      fi
       
     testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2; tmin=$?  
     testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2; tmax=$?  
     testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2; tmean=$?  
     testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2; tsd=$?  
     testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2; smin=$?  
     testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2; smax=$?  
     testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2; smean=$?  
     testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2; ssd=$?  
     testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2; umin=$?  
     testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2; umax=$?  
     testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2; umean=$?  
     testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2; usd=$?  
     testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2; vmin=$?  
     testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2; vmax=$?  
     testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2; vmean=$?  
     testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2; vsd=$?  
       
     dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \  
         $umin $umax $umean $usd $vmin $vmax $vmean $vsd  
207  }  }
208    
209  genmakemodel()  genmakemodel()
210  {  {
211      # genmakemodel directory      # genmakemodel directory
212      GENMAKE2="../../../tools/genmake2"      if test "x$NOGENMAKE" = xt ; then
213      (          echo "genmake skipped!"
214          cd $1;      else
215          printf 'genmake ... ' 1>&2          if test "x$BASH" = x ; then
216          # ../../../tools/genmake -ieee -mods=../code > make.log 2>&1              GENMAKE2="../../../tools/genmake2"
         $GENMAKE2  -ds --mods=../code "--optfile="$OPTFILE > make.log 2>&1  
         RETVAL=$?  
         for i in gm_state gm_optfile gm_local Makefile ; do  
             if test -r $i ; then  
                 cp $i $CDIR  
             fi  
         done  
         if test "x$RETVAL" != x0 ; then  
             tail make.log  
             echo "genmakemodel: genmake failed" 1>&2  
             cp make.log $CDIR  
             return 1  
217          else          else
218              echo "succesful" 1>&2              GENMAKE2="$BASH ../../../tools/genmake2 -bash $BASH"
219          fi          fi
220      )          (
221                cd $1;
222                command="$GENMAKE2  -ds -m $MAKE"
223                if test "x$ADM" = x ; then
224                    command="$command --mods=../code"
225                else
226                    command="$command --mods=../code_ad"
227                    command="$command -adof=../../../tools/adjoint_options/adjoint_staf"
228                fi
229                if test "x$OPTFILE" != xNONE ; then
230                    command="$command --optfile=$OPTFILE"
231                fi
232                if test "x$IEEE" != x ; then
233                    command="$command -ieee"
234                fi
235                printf 'genmake ... ' 1>&2
236                $command > make.log 2>&1
237                RETVAL=$?
238                cp Makefile $CDIR
239                if test "x$RETVAL" != x0 ; then
240                    tail make.log
241                    echo "genmakemodel: genmake failed" 1>&2
242                    cp genmake_* make.log $CDIR
243                    return 1
244                else
245                    echo "successful" 1>&2
246                fi
247            )
248        fi
249  }  }
250    
251  makeclean()  makeclean()
252  {  {
253      # makeclean directory      # makeclean directory
254      (      if test "x$NOCLEAN" = xt ; then
255          cd $1;          echo "make CLEAN skipped!"
256          rm -f output.txt      else
257          printf 'make CLEAN ... ' 2>&1          (
258          if test -r Makefile ; then              cd $1;
259              make CLEAN >> make.log 2>&1              if test -e output.txt ; then
260              RETVAL=$?                  rm -f output.txt
             if test "x$RETVAL" != x0 ; then  
                 tail make.log  
                 echo "makeclean: \"make CLEAN\" failed" 1>&2  
                 cp make.log $CDIR"/make.log"  
                 return 1  
261              fi              fi
262          fi              printf 'make CLEAN ... ' 2>&1
263          echo succesful 1>&2              if test -r Makefile ; then
264          exit 0                  $MAKE CLEAN >> make.log 2>&1
265      )                  RETVAL=$?
266                    if test "x$RETVAL" != x0 ; then
267                        tail make.log
268                        echo "makeclean: \"make CLEAN\" failed" 1>&2
269                        cp make.log $CDIR"/make.log"
270                        return 1
271                    fi
272                fi
273                echo successful 1>&2
274                exit 0
275            )
276        fi
277  }  }
278    
279  makedependmodel()  makedependmodel()
280  {  {
281      # makedependmodel directory      # makedependmodel directory
282      (      if test "x$NODEPEND" = xt ; then
283          cd $1;          echo "make depend skipped!"
284          printf 'make depend ... ' 1>&2      else
285          make depend >> make.log 2>&1          (
286          RETVAL=$?              cd $1;
287          if test "x$RETVAL" != x0 ; then              printf 'make depend ... ' 1>&2
288              tail make.log              $MAKE depend >> make.log 2>&1
289              echo "makedependmodel: make depend failed" 1>&2              RETVAL=$?
290              cp make.log $CDIR"/make.log"              if test "x$RETVAL" != x0 ; then
291              return 1                  tail make.log
292          else                  echo "makedependmodel: make depend failed" 1>&2
293              echo succesful 1>&2                  cp make.log $CDIR"/make.log"
294          fi                  return 1
295      )              else
296                    echo successful 1>&2
297                fi
298            )
299        fi
300  }  }
301    
302  makemodel()  makemodel()
# Line 231  makemodel() Line 306  makemodel()
306          cd $1;          cd $1;
307          if test -r Makefile ; then          if test -r Makefile ; then
308              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
309              make >> make.log 2>&1              if test "x$ADM" = x ; then
310                    $MAKE >> make.log 2>&1
311                else
312                    $MAKE adall >> make.log 2>&1
313                fi
314              RETVAL=$?              RETVAL=$?
315              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
316                  tail make.log                  tail make.log
# Line 239  makemodel() Line 318  makemodel()
318                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
319                  return 1                  return 1
320              else              else
321                  echo succesful 1>&2                  echo successful 1>&2
322              fi              fi
323          fi          fi
324      )      )
325  }  }
326    
327    symlink_mpifiles()
328    {
329        # Put special links so that MPI specific files are used
330        # This MUST be invoked between makeclean and makelinks because
331        # the Makefile will link to non-mpi files by default
332    
333        dir=$1
334        code_dir=$2
335        BUILD_DIR=$dir/$3
336        CODE_DIR=$dir/$code_dir
337    
338        # These are files that should replace their counter-part when using -mpi
339        MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`
340    
341        #  Is this an MPI run?
342        if test "x$MPI" = xt ; then
343            # YES: We symbolically link these files to the build
344            # dir so long as there is no real file in place
345            for ii in $MPI_FILES ; do
346                i=`echo $ii | sed 's:^\./::'`
347                name=`echo $i | sed 's:_mpi::' `
348                cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
349                RETVAL=$?
350                if test "x$RETVAL" != x0 ; then
351                    if ! test -f $BUILD_DIR/$i ; then
352                    #echo Linking $name to $i
353                        (cd $BUILD_DIR; ln -sf ../$code_dir/$i $name)
354                    fi
355                fi
356            done
357        else
358        # NO: We undo any _mpi symbolically linked files
359            for ii in $MPI_FILES ; do
360                i=`echo $ii | sed 's:^\./::'`
361                name=`echo $i | sed 's:_mpi::' `
362                if test -L $BUILD_DIR/$name ; then
363                    linktarg=`(cd $BUILD_DIR; readlink $name)`
364                    if test $linktarg = "../$code_dir/$name"_mpi ; then
365                    #echo Un-linking $name from $linktarg
366                        rm -f $BUILD_DIR/$name
367                    fi
368                fi
369            done
370        fi
371        
372    }
373    
374  linkdata()  linkdata()
375  {  {
376      # linkdata flag      # linkdata flag
377      #      #
378      # symbolically link data files to run directory      # symbolically link data files to run directory
379      if [ $1 -ne 0 ]; then      if test "x$1" = x1 ; then
380          ( cd $2 ;  ln -sf ../input/* . )          (
381                cd $2
382                if test "x$ADM" = x ; then
383                    files=`( cd ../input ; ls -1 | grep -v CVS )`
384                    for i in $files ; do
385                        if test ! -d "../input/"$i ; then
386                            ln -sf "../input/"$i $i
387                        fi
388                    done
389                else
390                    files=`( cd ../input ; ls -1 *.bin | grep -v CVS )`
391                    for i in $files ; do
392                        if test ! -d "../input/"$i ; then
393                            ln -sf "../input/"$i $i
394                        fi
395                    done
396                    files=`( cd ../input_ad ; ls -1 | grep -v CVS )`
397                    for i in $files ; do
398                        if test ! -d "../input_ad/"$i ; then
399                            ln -sf "../input_ad/"$i $i
400                        fi
401                    done
402                fi
403            )
404      fi      fi
405  }  }
406    
407  runmodel()  runmodel()
408  {  {
409      # runmodel directory exe      # runmodel directory
410      #      #
411      #  runs the model "exe" in "directory" (exe is relative to directory)      #  runs "$COMMAND in "directory"
412        #  (where "$COMMAND" is relative to "directory")
413      (      (
414          cd $1          cd $1
415          if [ -x $2 ]; then          printf 'runmodel ... ' 1>&2
416              if [ $quick -eq 0 ]; then          # make output.txt
417                  rm -f output.txt          echo
418              fi          # echo "COMMAND='$COMMAND'"
419              printf 'runmodel: ' 1>&2          # echo "pwd='"`pwd`"'"
420              make output.txt          ( eval $COMMAND ) >> run.log 2>&1
421              RETVAL=$?          RETVAL=$?
422              if test "x$RETVAL" = x0 ; then          if test "x$RETVAL" = x0 ; then
423                echo successful 1>&2
424                if test "x$ADM" = x ; then
425                  cp output.txt $CDIR"/output.txt"                  cp output.txt $CDIR"/output.txt"
                 return 0  
426              else              else
427                  return 1                  cp output.txt_adm $CDIR"/output.txt_adm"
428              fi              fi
429                return 0
430            else
431                tail run.log
432                echo failed 1>&2
433                cp run.log $CDIR"/run.log"
434                return 1
435          fi          fi
436      )      )
437  }  }
# Line 283  createcodelet() Line 440  createcodelet()
440  {  {
441      # create codelet for comparing model output      # create codelet for comparing model output
442    
443      echo -n "creating the comparison code...  "      printf "creating the comparison code...  "
444      cat > tmp_cmpnum.f <<EOFA      cat > tmp_cmpnum.c <<EOF
445        program cmpnum  #include <stdio.h>
446        implicit none  #include <math.h>
447        real*8 a,b,diff  int main( int argc, char** argv )  {
448        integer linnum,best    int linnum,best,lncnt;
449        best=-16    double a,b,diff;
450    99  read(*,*,end=70,err=60) linnum,a,b    best = -16;
451        diff=0.5*(abs(a)+abs(b))    lncnt = 0;
452  c     print *,a,b,diff,abs(a-b)/diff    while( 1 & (lncnt+=1) < 999 )  {
453        if (diff.gt.1.e-12) then      scanf("%d", &linnum);
454          diff=abs(a-b)/diff      if (linnum == -1)  break;
455          if (diff.gt.0.) then      scanf("%lf", &a);  scanf("%lf", &b);
456  c         print *,int(log10(diff)),diff      diff = 0.5*(fabs(a)+fabs(b));
457            linnum=int(log10(diff))      if (diff > 1.e-12) {
458            best=max(best,linnum)        diff=fabs(a-b)/diff;
459          endif        if (diff > 0.0) {
460        else          linnum = (int)log10(diff);
461          if (best.eq.-16.and.diff.ne.0.) best=-22          best = (best > linnum) ? best : linnum;
462        endif        }
463        goto 99        else {
464    60  stop 'cmpnum: An error occured reading a,b'          if (best == -16 && diff != 0)  best = -22;
465    70  print *,-best        }
466        end      }
467  EOFA    }
468      if (lncnt == 999) best=-29;
469      printf("%d\n", -best);
470      return 0;
471    }
472    EOF
473        cc -o tmp_cmpnum tmp_cmpnum.c -lm
474    
475      f77 tmp_cmpnum.f      if [ -x ./tmp_cmpnum ]; then
     if [ -x ./a.out ]; then  
476          echo "OK"          echo "OK"
477          return 0          return 0
478      else      else
479          echo          echo
480          echo "createcodelet: failed to compile codelet" | tee          echo "ERROR: failed to compile comparison code"
481          exit 1          exit 1
482      fi      fi
483  }  }
# Line 347  show_help() Line 509  show_help()
509  {  {
510      cat - << EOF      cat - << EOF
511  $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]  $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]
512   -help      Show this help message  
513   -quick     Skip "genmake" and "make depend" if the Makefile exists   -help|-h      Show this help message
514   -quiet     Reduce the amount of output   -quiet     Reduce the amount of output
515   -verbose   Produce copious amounts of output   -verbose   Produce copious amounts of output
516   -debug     Produce even more output which will mean nothing to most   -debug     Produce even more output which will mean nothing to most
517   -force     Do "make CLEAN" before compiling. This forces a complete rebuild.   -force     Do "make CLEAN" before compiling. This forces a complete rebuild.
518   -clean     Do "make CLEAN" after compiling and testing.   -clean     Do "make CLEAN" after compiling and testing.
  -noieee    By default, $0 uses the -ieee option for genmake. This turns it off.  
519   -cleanup   Aggresively removes all model output, executables and object files   -cleanup   Aggresively removes all model output, executables and object files
520              and then exits. Use with care.              and then exits. Use with care.
521    
# Line 376  scandirs() Line 537  scandirs()
537    
538    
539  ###############################################################################  ###############################################################################
 ###############################################################################  
 ###############################################################################  
540    
541    
542  #  Default properties  #  Default properties
543  debug=0  debug=0
544  verbose=1  verbose=1
 quick=0  
545  clean=0  clean=0
 ieee=1  
546  expts=''  expts=''
547    # ieee=1
548    
549    IEEE=true
550    if test "x$MITGCM_IEEE" != x ; then
551        IEEE=$MITGCM_IEEE
552    fi
553    
554    
555  OPTFILES=  CLEANUP=f
556  ADDRESSES=edhill@mitgcm.org  QUICK=f
557    NOGENMAKE=f
558    NOCLEAN=f
559    NODEPEND=f
560    
561    BASH=
562    OPTFILE=NONE
563    ADDRESSES=
564  TESTDIRS=  TESTDIRS=
565  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
566    HAVE_MPACK=
567  MPACK="$MPACKDIR/mpack"  MPACK="$MPACKDIR/mpack"
568    COMMAND=
569    MAKE=make
570    MPI=f
571    DELDIR=
572    
573  echo -n "parsing options...  "  ADM=
574    
575    printf "parsing options...  "
576    
577  ac_prev=  ac_prev=
578  for ac_option ; do  for ac_option ; do
# Line 414  for ac_option ; do Line 592  for ac_option ; do
592              usage ;;              usage ;;
593                    
594          -optfile | --optfile | -of | --of)          -optfile | --optfile | -of | --of)
595              ac_prev=OPTFILES ;;              ac_prev=OPTFILE ;;
596          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
597              OPTFILES=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
598                    
599          -addr | --addr | -a | --a)          -addr | --addr | -a | --a)
600              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
# Line 428  for ac_option ; do Line 606  for ac_option ; do
606          -tdir=* | --tdir=*)          -tdir=* | --tdir=*)
607              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
608    
609          -quick) quick=1 ;;          -bash | --bash | -b | --b)
610                ac_prev=BASH ;;
611            -bash=* | --bash=*)
612                BASH=$ac_optarg ;;
613    
614            -command | --command | -c | --c)
615                ac_prev=COMMAND ;;
616            -command=* | --command=*)
617                COMMAND=$ac_optarg ;;
618    
619            -make | --make | -m | --m)
620                ac_prev=MAKE ;;
621            -make=* | --make=*)
622                MAKE=$ac_optarg ;;
623    
624            -clean | --clean)
625                CLEANUP=t ;;
626    
627            -quick | --quick | -q | --q)
628                QUICK=t ;;
629            -nogenmake | --nogenmake | -ng | --ng)
630                NOGENMAKE=t ;;
631            -noclean | --noclean | -nc | --nc)
632                NOCLEAN=t ;;
633            -nodepend | --nodepend | -nd | --nd)
634                NODEPEND=t ;;
635    
636            -mpi) MPI=t ;;
637    
638            -adm | -ad) ADM=t ;;
639    
640            -ieee) IEEE=true ;;
641            -noieee) IEEE= ;;
642    
643          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
644          -debug) debug=1 ;;          -debug) debug=1 ;;
         -clean) clean=1 ;;  
         -noieee) ieee=0 ;;  
645          -quiet) verbose=0 ;;          -quiet) verbose=0 ;;
646    
647            -deldir | -dd) DELDIR=t ;;
648    
649          -*)          -*)
650              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
651              usage              usage
# Line 449  for ac_option ; do Line 660  for ac_option ; do
660            
661  done  done
662    
663    if test "x$QUICK" = xt ; then
664        NOGENMAKE=t
665        NOCLEAN=t
666        NODEPEND=t
667    fi
668    
669  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
670      TESTDIRS=`scandirs`      TESTDIRS=`scandirs`
671  fi  fi
672    
673    if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
674        OPTFILE=$MITGCM_OF
675    fi
676    
677    if test "x$ADM" = xt -a "x$COMMAND" = x ; then
678        COMMAND="./mitgcmuv_ad > output.txt_adm 2>&1"
679    fi
680    
681    if test "x$COMMAND" = x ; then
682        COMMAND="make output.txt"
683    fi
684    
685  echo "OK"  echo "OK"
686    
687  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
688  createcodelet  createcodelet
689    
690  #  build the mpack utility  #  build the mpack utility
691  build_mpack  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
692        echo "skipping mpack build"
693    else
694        build_mpack
695    fi
696    
697  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
698  MACH=`hostname`  MACH=`hostname`
699  UNAMEA=`uname -a`  UNAMEA=`uname -a`
700  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
701  BASE=$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
702  DNUM=0  DNUM=0
703  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
704  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 475  done Line 708  done
708  mkdir $DRESULTS  mkdir $DRESULTS
709  RETVAL=$?  RETVAL=$?
710  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
711      echo "Error: can't create results directory \"./$DRESULTS\""      echo "ERROR: Can't create results directory \"./$DRESULTS\""
712      exit 1      exit 1
713  fi  fi
714  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
715  date > $SUMMARY  printf "Start time:  " >> $SUMMARY
716  cat << EOF >> $SUMMARY  start_date=`date`
717    echo $start_date > $SUMMARY
718    
719    of_path=
720    if test "x$OPTFILE" != xNONE ; then
721        if test -r $OPTFILE ; then
722            # get the path
723            path=${OPTFILE%/*}
724            if test "x$path" = x ; then
725                of_path=`pwd`
726            else
727                of_path=`( cd $path > /dev/null 2>&1 ; pwd )`
728            fi
729            file=${OPTFILE##*/}
730            OPTFILE=$of_path/$file
731            cp $OPTFILE $DRESULTS
732            echo >> $SUMMARY
733            echo "  OPTFILE=$OPTFILE" >> $SUMMARY
734        else
735            echo | tee $SUMMARY
736            echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY
737            exit 1
738        fi
739    else
740        echo >> $SUMMARY
741        echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY
742        echo "   so the genmake default will be used." >> $SUMMARY
743    fi
744    echo
745    echo >> $SUMMARY
746    if test "x$ADM" = x ; then
747        cat << EOF | tee -a $SUMMARY
748                  T           S           U           V                  T           S           U           V
749  G D M    c        m  s        m  s        m  s        m  s  G D M    c        m  s        m  s        m  s        m  s
750  E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .
# Line 488  N n k u  2  i  a  a  d  i  a  a  d  i  a Line 752  N n k u  2  i  a  a  d  i  a  a  d  i  a
752  2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .
753    
754  EOF  EOF
755    else
756        echo "ADJOINT=true" >> $SUMMARY
757        echo >> $SUMMARY
758        cat << EOF | tee -a $SUMMARY
759    G D M    C  G
760    E p a R  o  r
761    N n k u  s  a
762    2 d e n  t  d
763    
764  NDIR=0  EOF
765    fi
766    
767  #  For each optfile...  #  ...and each test directory...
768  for OPTFILE in $OPTFILES ; do  for dir in $TESTDIRS ; do
769        
770        #  Cleanup only!
771        if test "x$CLEANUP" = xt ; then
772            if test -r $dir/build/Makefile ; then
773                ( cd $dir/build ; make CLEAN )
774            fi
775            if test -r $dir/input/Makefile ; then
776                ( cd $dir/input ; make CLEAN )
777            fi
778            continue
779        fi
780    
781        #  Verify that the testdir exists and contains previous
782        #  results in the correct location--or skip this directory!
783        fout=
784        if test "x$ADM" = x ; then
785            fout=$dir"/results/output.txt"
786        else
787            fout=$dir"/results_ad/output.txt_adm"
788        fi
789        if test ! -r $fout ; then
790            echo "can't read \"$fout\" -- skipping $dir"
791            continue
792        fi
793    
794      OPTFILE=`pwd`"/$OPTFILE"      builddir="input"
795      if test ! -r $OPTFILE ; then      rundir="input"
796          echo "Error: can't read optfile \"$OPTFILE\""      use_seperate_build=0
797          exit 1      if test -d $dir/build -a -r $dir/build ; then
798            builddir="build"
799            rundir="build"
800            use_seperate_build=1
801            linkdata $use_seperate_build $dir/$rundir
802      fi      fi
     echo  
     echo "OPTFILE=$OPTFILE" >> $SUMMARY  
     echo >> $SUMMARY  
803            
804      #  ...and each test directory...      #  Check whether there are "extra runs" for this testdir
805      for dir in $TESTDIRS ; do      extra_runs=
806                if test "x$ADM" = x -a "x$use_seperate_build" = x1 ; then
807          #  Create an output dir for each OPTFILE/tdir combination          ex_run_dirs=`( cd $dir ; echo input.* )`
808          CDIR=$DRESULTS"/"$DRESULTS"_"$NDIR          echo "ex_run_dirs='$ex_run_dirs'"
809          mkdir $CDIR          for exd in $ex_run_dirs ; do
810          CDIR=`pwd`"/$CDIR"              name=`echo $exd | sed -e 's/input.//g'`
811                outf="$dir/results/output.txt.$name"
812                if test -f $outf -a -r $outf ; then
813                    extra_runs="$extra_runs $name"
814                fi
815            done
816        fi
817    
818          #  ...configue, make, run, and compare the output.      if test "x$ADM" = x ; then
819          echo "-------------------------------------------------------------------------------"          code_dir=code
820          echo          CODE_DIR=$dir/code
821          echo "Experiment:  $dir"      else
822          echo          code_dir=code_ad
823          unset genmake makedepend make run          CODE_DIR=$dir/code_ad
824          results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      fi
825          ( cd $dir/input; rm -f *.{o,f,c,F} *.[f,F]90 work* output.txt Make* make.log; )      BUILD_DIR=$dir/$builddir
         if [ -r $dir/build ]; then  
             seperatebuilddir=1  
             builddir=build  
             rundir=build  
             ( cd $dir/build; ln -sf ../input/* . )  
         else  
             seperatebuilddir=0  
             builddir=input  
             rundir=input  
         fi  
826    
827          #  Verify that the testdir exists and contains previous      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
828          #  results in the correct location--or skip this directory!          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
829          if test ! -r $dir"/results/output.txt" ; then          continue
830              echo | tee $SUMMARY      fi
831              echo "can't read \"$dir/results/output.txt\" -- skipping $dir" \  
832                  | tee $SUMMARY      echo "-------------------------------------------------------------------------------"
833              continue      echo
834          fi      echo "Experiment:  $dir"
835        echo
836        unset genmake makedepend make run
837        results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
838    
839        #  Create an output dir for each OPTFILE/tdir combination
840        rel_CDIR=$DRESULTS"/"$dir
841        mkdir $rel_CDIR
842        CDIR=`pwd`"/$rel_CDIR"
843        
844        if test "x$CLEANUP" = xt ; then
845            makeclean $dir/$builddir
846        else
847          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
848              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
849                && symlink_mpifiles $dir $code_dir $builddir \
850              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
851              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
852              && linkdata $seperatebuilddir $dir/$rundir \              && linkdata $use_seperate_build $dir/$rundir \
853              && runmodel $dir/$builddir mitgcmuv && run=Y \              && runmodel $dir/$rundir && run=Y \
854              && results=`testoutput $dir $rundir`              && results=`testoutput $dir $rundir`
855        fi
856        
857        echo
858        if test "x$ADM" = x ; then
859            fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
860          echo          echo
861          formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \          echo "$fres" >> $SUMMARY
862              ${run:-N} $results          echo "fresults='$fres'" > $CDIR"/summary.txt"
         echo  
         formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \  
             ${run:-N} $results >> $SUMMARY  
         echo "fresults='" > $CDIR"/summary.txt"  
         formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \  
             ${run:-N} $results >> $CDIR"/summary.txt"  
         echo "'" >> $CDIR"/summary.txt"  
863          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
864          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
865          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
866          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
867    
868          (          OLD_COMMAND=$COMMAND
869              cd $DRESULTS          COMMAND="./mitgcmuv > output.txt"
870              tar -cf $NDIR".tar" $DRESULTS"_"$NDIR > /dev/null 2>&1          for ex in $extra_runs ; do
871              gzip $NDIR".tar"              test -e "$dir/tr_run.$ex" && rm -rf "$dir/tr_run.$ex"
872          )              mkdir "$dir/tr_run.$ex"
873                links=`( cd "$dir/input" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`
874                (
875                    cd "$dir/tr_run.$ex"
876                    for i in $links; do
877                        ln -s ../input/$i $i
878                    done
879                )
880                links=`( cd "$dir/input.$ex" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`
881                (
882                    cd "$dir/tr_run.$ex"
883                    for i in $links; do
884                        test -e $i  &&  rm -f $i
885                        ln -s ../input.$ex/$i $i
886                    done
887                    ln -s ../$builddir/mitgcmuv mitgcmuv
888                )
889                runmodel $dir/tr_run.$ex && run=Y \
890                    && results=`testoutput $dir tr_run.$ex "."$ex`
891                fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
892                fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
893                fres="$fres.$ex"
894                echo
895                echo "$fres" >> $SUMMARY
896                echo "fresults='$fres'" > $CDIR"/summary.txt"
897                echo "MACH='$MACH'" >> $CDIR"/summary.txt"
898                echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
899                echo "DATE='$DATE'" >> $CDIR"/summary.txt"
900                echo "tdir='$dir'" >> $CDIR"/summary.txt"
901            done
902            COMMAND=$OLD_COMMAND
903        else
904            fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
905            fres=$fres"$results   $dir"
906            echo
907            echo "$fres" >> $SUMMARY
908            echo "fresults='$fres'" > $CDIR"/summary.txt"
909            echo "MACH='$MACH'" >> $CDIR"/summary.txt"
910            echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
911            echo "DATE='$DATE'" >> $CDIR"/summary.txt"
912            echo "tdir='$dir'" >> $CDIR"/summary.txt"
913        fi
914        
915        echo "-------------------------------------------------------------------------------"
916        
917    done
918    
919          $MPACK -s MITgcm-test -m 1000000 $DRESULTS"/"$NDIR".tar.gz" $ADDRESSES  printf "Start time:  " >> $SUMMARY
920    echo $start_date >> $SUMMARY
921    printf "End time:    " >> $SUMMARY
922    date >> $SUMMARY
923    
924    #  If addresses were supplied and mpack built successfully, then try
925    #  to send email using mpack.
926    if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
927        echo "No results email was sent."
928    else
929        if test "x$HAVE_MPACK" = xt ; then
930            tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \
931                && gzip $DRESULTS".tar" \
932                && $MPACK -s MITgcm-test -m 1500000 $DRESULTS".tar.gz" $ADDRESSES
933          RETVAL=$?          RETVAL=$?
934          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
935              echo "Warning: \"$MPACK\" failed -- please contact <edhill@mitgcm.org>"              echo
936                echo "Warning: The tar, gzip, & mpack step failed.  Please send email"
937                echo "  to <MITgcm-support@mitgcm.org> for help.  You may copy the "
938                echo "  summary of results from the directory \"$DRESULTS\"."
939                echo
940          else          else
941              rm -f $DRESULTS"/"$NDIR".tar*"              echo
942                echo "An email containing results was sent to the following addresses:"
943                echo "  \"$ADDRESSES\""
944                echo
945          fi          fi
946            test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
947            test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
948        fi
949    fi
950    
951          NDIR=$(( $NDIR + 1 ))  # rm -f tmp_cmpnum.f a.out
952            rm -f tmp_cmpnum.c tmp_cmpnum
     done  
 done  
953    
954  rm tmp_cmpnum.f a.out  if test "x$CLEANUP" != xt ; then
955        cat $SUMMARY
956        if test -e tr_out.txt ; then
957            mv tr_out.txt tr_out.txt.old
958        fi
959        cat $SUMMARY > tr_out.txt
960    fi
961    
962  cat $SUMMARY  if test "x$DELDIR" = xt ; then
963        rm -rf $DRESULTS
964    fi
965    

Legend:
Removed from v.1.2  
changed lines
  Added in v.1.42

  ViewVC Help
Powered by ViewVC 1.1.22